<?php
/*
YaotGui Main menu


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/

require('lib.php');
$menu = new LibList('menu', 'menu');
foreach(Settings::$MAIN_MENU as $text => $path)
{
   $menu->addItem(array('path' => $path), $text);
}
?>
<html>
<head>
<?php
JSLib();
defaultStyles();
?>
<style>
body {background: #000000; color: #ffffff; font-family: Sans-serif; font-size: 20px;
      position: absolute; left: <?php echo TV::LEFT?>px; top: <?php echo TV::TOP?>px; width: <?php echo TV::WIDTH?>px; height: <?php echo TV::HEIGHT?>px; overflow: auto;}
#title {overflow: hidden; white-space: nowrap; position: absolute; left: 25px; top: 2px; width: <?php echo TV::WIDTH-2*25;?>px;}
.menu {position: absolute; left: 25px; top: 35px; width: <?php echo TV::WIDTH-2*25;?>px; height: <?php echo TV::HEIGHT-2*35;?>px;}
.menu_item, .menu_item_sel {}
</style>
<script src="debug.js"></script>
<script>
var TV_LEFT = <?php echo TV::LEFT?>;
var TV_TOP = <?php echo TV::TOP?>;
var TV_WIDTH = <?php echo TV::WIDTH?>;
var TV_HEIGHT = <?php echo TV::HEIGHT?>;

function load()
{
    if(!_debugMode)
    {
	toiEnv.input.addEventListener(toiEnv.input.ON_KEY_DOWN, userinput);

	_video = toiEnv.createMediaPlayer();
	
	BrowserWindow = toiEnv.browserWindow;
	BrowserWindow.enableColorKeying();
	BrowserWindow.setColorKey(0x000001);
	BrowserWindow.setTransparency(BrowserWindow.COLOR_KEY_SOLID_COLOR);
    }
}

function userinput (event)
{
    var key = event.extendedKeyCode;
    event.consume();
    onKey(key);
}

function onKey(key)
{
    try
    {
        switch (key)
        {
	    //boot loader
	case 7733366: //BTN_YELLOW
	    var newLocation = "/iptvgui/initial.html";
	    top.location = newLocation;
	    break;
	case BTN_QUESTIONMARK:
	    location.reload();
	    break;
	case BTN_MIDUP:
	    __menu_move(-1, true);
	    break;
	case BTN_MIDDN:
	    __menu_move(1, true);
	    break;
	case BTN_MIDOK:
	    goTo(__menu_getSelectedValue('path'));
	    break;
	case BTN_PPLUS:
	    __menu_move(-5, 0, false);
	    break;
	case BTN_PMINUS:
	    __menu_move(5, 0, false);
            break;
	default:
	    //	    alert(key);
	    break;
        }
    }
    catch(err)
    {
	alert(err.message);
    }
}

function goTo(path)
{
    window.location = path;
}

function debugKey(e)
{
    if(!e)
	e = window.event;

    onKey(e.keyCode);
}

document.onkeyup = debugKey;
</script>
</head>
<body onload="load()">
    <div id="title">YaotGui</span></div>

    <?php $menu->printHtml(); ?>
</body>
</html>
