<?php
/*
YaotGui VLC interface


This file is part of YaotGui.

YaotGui is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

YaotGui is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with YaotGui.  If not, see <http://www.gnu.org/licenses/>.

Copyright 2008 Thomas Axelsson

*/

require('lib.php');

//header("Content-Type: text/xml\n");
header("Content-Type: text/plain\n");

$_lastOutput;

function sendReq($req)
{
   global $_lastOutput;
   return ($_lastOutput = file_get_contents('http://' . Settings::VLC_HTTP . '/requests/' . $req));
}

function sendCmd($cmd)
{
   return sendReq('status.xml?' . $cmd);
}

function getPlaylist()
{
   return sendReq('playlist.xml');
}

function translatePath($file)
{
   foreach(Settings::$VLC_FOLDER_TRANSLATE as $from => $to)
   {
      $file = str_replace($from, $to, $file);
   }

   if(Settings::VLC_FOLDER_TRANSLATE_TO_WIN)
      $file = str_replace('/', '\\\\', $file);

   return $file;
}

function newBroadcast($file)
{
   //get id?
   $file = translatePath($file);
   $resp = sendCmd('command=in_enqueue&input=' . urlencode($file . ' :sout=#transcode{vcodec=mpgv,vb=4096,scale=1,acodec=mp2a,ab=512,channels=2,fps=25}:std{access=http,mux=ts,dst=' . Settings::VLC_STREAM . '}'));
//   $resp = sendCmd('command=in_enqueue&input=' . urlencode($file . ' :sout=#transcode{vcodec=mp2v,vb=4096,scale=1,acodec=mp2a,ab=512,channels=2}:std{access=http,mux=ts,dst=' . Settings::VLC_STREAM . '}'));
}

function getLatestId()
{
   $playlist = getPlaylist();
   if(preg_match('|<leaf id="(\d+)"[^<]*</node>|s', $playlist, $matches) === 1)
      return $matches[1];
   return NULL;
}

getLatestId();

function del()
{
   sendCmd('command=pl_empty');
}

function play($id = 0)
{
   sendCmd('command=pl_play&id=' . $id);
}

function pause($id = 0)
{
   sendCmd('command=pl_pause&id=' . $id);
}

function stop()
{
   sendCmd('command=pl_stop');
}

function seek($val)
{
   echo 'command=seek&val=' . $val;
   sendCmd('command=seek&val=' . $val);
}


$_cmd = $_REQUEST['cmd'];
$_val = $_REQUEST['val'];

switch($_cmd)
{
   case 'new':
      if($_val && isInAllowedPath($_val))
      {
	 del(); //check existance?
	 newBroadcast($_val);
//	 $_SESSION['vlcPlId'] = getLatestId();
      }
      break;
   case 'del':
      del();
      break;
   case 'play':
      play(getLatestId());
      break;
   case 'pause':
      pause(getLatestId());
      break;
   case 'stop':
      stop();
      break;
   case 'seek':
      if($_val)
      {
	 $val = str_replace(array('+', '-'), array('%2b', '%2d'), $_val);
	 seek($val);
      }
      break;
}

echo $_lastOutput;
?>
